#*********************************************************************
#*** ResourcePool::Resource::Wrap
#*** Copyright (c) 2002 by Markus Winand <mws@fatalmind.com>
#*** $Id: Wrap.pm,v 1.3 2003/01/04 11:20:31 mws Exp $
#*********************************************************************

package ResourcePool::Resource::Wrap;

use strict;
use vars qw($VERSION);

$VERSION = "1.0000";

sub new($$) {
	my $proto = shift;
	my $class = ref($proto) || $proto;
	my $wrap = shift;
	my $self = {};
	$self->{wrap} = $wrap;

	bless($self, $class);

	return $self;
}

sub close($) {
	my ($self) = @_;
	return $self->{wrap}->close();
}

sub fail_close($) {
	my ($self) = @_;
	return $self->{wrap}->fail_close();
}

sub precheck($) {
	my ($self) = @_;
	return $self->{wrap}->precheck();
}

sub postcheck($) {
	my ($self) = @_;
	return $self->{wrap}->postcheck();
}

sub get_plain_resource($) {
	my ($self) = @_;
	return $self->{wrap}->get_plain_resource();
}

sub _my_very_private_and_secret_test_hook($$) {
	my ($self, $value) = @_;
	return $self->{wrap}->_my_very_private_and_secret_test_hook($value);
}

1;
